# 11aug24 Software Lab. Alexander Burger

(symbols '(android pico))

(local) (TYPE_PRESSURE SENSOR_DELAY_NORMAL *SensorMan getDefaultSensor
onSensorChanged values registerListener unregisterListener getAltitude)

(de TYPE_PRESSURE . 6)  # Sensor
(de SENSOR_DELAY_NORMAL . 3)  # SensorManager

(default *SensorMan (java CONTEXT 'getSystemService "sensor"))  # SensorManager


(symbols 'pico~barometer 'gis 'android 'pico)

(local) (*BaroLsn *Sse *Usec *Latitude *Longitude *SeaLevel *Pressure display)

(setq *BaroLsn (java T "android.hardware.SensorEventListener"))

(def 'onSensorChanged *BaroLsn
   '((Evt)
      (co 'barometer
         (for (Cnt 1  T  (min 99 (inc Cnt)))
            (let Sum 0
               (do Cnt
                  (inc 'Sum (; (wipe Evt) values 1))
                  (yield) )
               (setq *Pressure (*/ Sum Cnt)) )
            (ifn (gps)
               (off *Latitude *Longitude)
               (setq *Latitude (car @)  *Longitude (cdr @))
               (when (> (usec) *Usec)
                  (setq *SeaLevel
                     (ssl "api.open-meteo.com"  # https://open-meteo.com/en/docs
                        (pack
                           "v1/forecast?latitude="
                           (lat *Latitude)
                           "&longitude="
                           (lon *Longitude)
                           "&current=pressure_msl" )
                        (and
                           (from "\"current\":")
                           (from "\"pressure_msl\":")
                           (format (till "}" T) 6) ) ) )
                  (setq *Usec (+ (usec) `(* 15 60 1000000))) ) )  # 15 min
            (serverSend *Sse
               (display) ) ) ) ) )

(de display ()
   (when *Pressure
      (prin
         (if (onOff (T)) "*" " ")
         "<br/>"
         (round *Pressure 2)
         " hPa<br/><br/>"
         (fmt *Latitude ", " *Longitude T)
         "<br/>"
         (or (round *SeaLevel 2) "(?)")
         " hPa<br/>"
         (round
            (java *SensorMan 'getAltitude  # 1 hPa / 8 m  ->  1 Pa / 8 cm
               (cons (or *SeaLevel 1013.25) -1.0)
               (cons *Pressure -1.0) )
            2 )
         " m" ) ) )
